% learning_clafic.m ؽʬˡ
clear
close all

r=1;     % ʬ֤μ(ƥ饹, 1<=r<=9)
alp=0.1; % ؽ (0<alp<1)

load('traiX.mat');    % traiΥꥸʥȥ٥ɹ
load('queryX.mat');   % queryΥꥸʥȥ٥ɹ

nclass=40; % 饹
[d ntrai] =size(trai.X);   % μdȷntrai
[d nquery]=size(query.X);  % μdȥƥȲnquery

% ʬ֤ľϤλ
for jj = 1 : nclass
	% ٥뤬jjηY˳Ǽ
	X=trai.X(:,find(trai.label==jj));
	[d n] = size(X);           % XΥ n<<d
	N = X'*X;                  % n x nξN׻
	rdim = rank(N);            % Nγ򻻽

	% ͭ٥ȥ¤٤Uλ
	[eig_vec eig_val] = eig(N); % Nθͭͤȸͭ٥ȥ
	[value index]=sort(diag(eig_val),'descend'); % ߽ͭͤ¤ؤ
	U = X * eig_vec(:,index(1:rdim)) * diag(sqrt(1./value(1:rdim)) );

	C(jj).U  = U; % 饹jjθͭ٥ȥ
	fprintf(2,'class %d --- ok\n',jj);
end

%% ؽ
s=zeros(nclass,1);         % ٳǼѿ
MAX_ITE=100;               % ؽ
obj_func=zeros(MAX_ITE,1); % ؽƥåפȤμΨ

% Uν
for jj = 1 : nclass
	LC(jj).U=C(jj).U(:,1:r);
end

for t=1:MAX_ITE

	% ѿν
	for jj = 1 : nclass
		dC(jj).U=zeros(d,r);
  end

	% ѤƳؽ
  for ii = 1 : ntrai
  	
  	% ƥ饹Ȥٷ׻
  	for jj = 1 : nclass
  		s(jj)=norm((LC(jj).U)'*trai.X(:,ii)).^2;
  	end

  	% ٤߽˥  	
  	[value index]=sort(s,'descend');
  	
  	% Υ٥pp˳Ǽ
  	pp=trai.label(ii);
  	
  	% Υ٥pp˳Ǽ
  	if index(1)~=trai.label(ii)
  		nn=index(1);  % ̤ξϤΥ٥nn
  	else
  		nn=index(2);  % ̤ξܤΥ饹Υ٥nn
    end
    
    % η׻
    s1=s(pp);, s2=s(nn);
    u=(s2-s1)./(s1+s2);
    f=1./(1+exp(-u.*t));, df=alp.*t.*f.*(1-f);
    ds1=s2./(s1+s2).^2;, ds2=s1./(s1+s2).^2;
		
		% ɾؿͤη׻
		obj_func(t)=obj_func(t)+f;

    % ̤η׻
    dC(pp).U=dC(pp).U+df.*ds1.*(trai.X(:,ii)*((trai.X(:,ii))'*LC(pp).U));
    dC(nn).U=dC(nn).U-df.*ds2.*(trai.X(:,ii)*((trai.X(:,ii))'*LC(nn).U));
	end
	
  fprintf(2,'learning step t = %3d, object function value =%f\n',t,obj_func(t));
	
	% ɾؿѲʤä齪λ
	if t>1
		if abs(obj_func(t-1)-obj_func(t))<1E-5
			break;
		else
			% ľ
			for jj = 1 : nclass
				LC(jj).U=LC(jj).U+dC(jj).U;
				LC(jj).U=orth(LC(jj).U);
			end
		end
	else
		for jj = 1 : nclass
			LC(jj).U=LC(jj).U+dC(jj).U;
			LC(jj).U=orth(LC(jj).U);
		end
	end
end

% ؽΥƥȲμΨ
accuracy=0;             % Ψ
for ii = 1 : nquery
	% ƥ饹٤׻
	for jj = 1 : nclass
		s(jj)=norm((LC(jj).U)'*query.X(:,ii));
	end
	% ٤Ȥʤ륯饹
	[value index]=max(s);
	% ٤Ȥʤ륯饹ȥƥȥǡΥ٥뤬
	if index==query.label(ii)
		accuracy=accuracy+1;
	end
end
% ΨɴʬΨɽ
accuracy=(accuracy./nquery).*100;
fprintf('dimensionality r=%d, accuracy : %2.1f \n',r,accuracy);
figure(1),clf,plot(obj_func(1:t));
xlabel('learning step t');, ylabel('Object function value');
